#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#define ORIGINAL_FLAG "\xe5\xff\xf8\xff\xd7\xef\x9c\xfb\xee\x9c\xf5\xff\xe4\xed\xfe\xfc\xff\xe4\x9c\x9c\xf8\x9f\xfe\xd1"

char* duplicate_string(const char *str) {
    char *duplicate = malloc(strlen(str) + 1);
    if (duplicate != NULL) {
        strcpy(duplicate, str);
    }
    return duplicate;
}

void texas_shootout() {
    unsigned int seed = rand(); 
    int wins_needed = 3;

    char *encrypted_flag = duplicate_string(ORIGINAL_FLAG);
    char output[strlen(encrypted_flag) + 1];

    double delay = (rand() % 2000 + 1000) / 1000.0;

    printf("Welcome to the Texas Shootout CTF Challenge!\n");
    printf("Press Enter to start...\n");
    getchar();
    sleep(5);

    printf("\nDUEL!\n");

    time_t start_time = time(NULL);

    printf("Press Enter to draw and shoot!\n");
    getchar();

    time_t end_time = time(NULL);
    double reaction_time = difftime(end_time, start_time);

    if (reaction_time <= 0) {
        printf("You're too trigger-happy! Wait for the 'Press Enter' prompt.\n");
        return;
    }

    printf("\nResults:\n");
    printf("Opponent drew in %.2f seconds.\n", delay);
    printf("Your reaction time: %.2f seconds.\n", reaction_time);

    if (reaction_time < delay) {
        printf("You shot first! You win the duel!\n");
        printf("\nCongratulations! You've revealed the flag: %s\n", encrypted_flag);
    } else if (reaction_time > delay) {
        printf("Opponent shot first! You lose the duel.\n");
    } else {
        printf("It's a draw in this Texas shootout!\n");
    }

    free(encrypted_flag);
}

void init(){
    fclose(stderr);
    setvbuf(stdin,  0, 2, 0);
    setvbuf(stdout, 0, 2, 0);
}

int main() {
    init();
    srand(time(NULL));
    texas_shootout();

    return 0;
}
