<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Sheriff Report</title>
    <link rel="stylesheet" href="style.css">
  </head>
  <body>
    <div class="container">
      <header>
        <h1>Submit Report</h1>
      </header>
      <main>
        <?php
          if (!$_POST["h-captcha-response"]) {
              die("<header>Captcha not completed.</header>");
          }
          $secret = getenv("secret");
          $response = $_POST["h-captcha-response"];

          $url = "https://api.hcaptcha.com/siteverify";
          $data = [
              "response" => $response,
              "secret" => $secret,
          ];

          $options = [
              "http" => [
                  "header" =>
                      "Content-type: application/x-www-form-urlencoded\r\n",
                  "method" => "POST",
                  "content" => http_build_query($data),
              ],
          ];

          $context = stream_context_create($options);
          $result = file_get_contents($url, false, $context);

          if ($result === false) {
              die("<header>Failed to validate captcha.</header>");
          }

          $resultJson = json_decode($result);
          if ($resultJson->success != "true") {
              die("<header>Invalid captcha.</header>");
          }
          $id = $_POST['id'];
          if (!preg_match('/^[a-zA-Z0-9]{25}$/', $id)) {
              die("<header>Invalid ID. ID must consist of 25 alphanumeric characters.</header>");
          }
          if (!file_exists("../reports/$id.html")) {
              die("<header>Invalid ID. Report does not exist.</header>");
          }
          $result = file_put_contents('../reports/fetch.php', "$id," , FILE_APPEND | LOCK_EX);
          if ($result === false) {
            die("<header>Failed to log report. Please try again.</header>");
          }
          echo "<header>Report submitted.</header>";
        ?>
      </main>
    </div>
  </body>
</html>
