<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Sheriff Report</title>
    <link rel="stylesheet" href="style.css">
</head>
<body>
<div class="container">
    <header>
        <h1>Make a Report</h1>
    </header>
    <main>
        <?php
        if (!$_POST["h-captcha-response"]) {
            die("<header>Captcha not completed.</header>");
        }
        $secret = getenv("secret");
        $response = $_POST["h-captcha-response"];

        $url = "https://api.hcaptcha.com/siteverify";
        $data = [
            "response" => $response,
            "secret" => $secret,
        ];

        $options = [
            "http" => [
                "header" =>
                    "Content-type: application/x-www-form-urlencoded\r\n",
                "method" => "POST",
                "content" => http_build_query($data),
            ],
        ];

        $context = stream_context_create($options);
        $result = file_get_contents($url, false, $context);

        if ($result === false) {
            die("<header>Failed to validate captcha.</header>");
        }

        $resultJson = json_decode($result);
        if ($resultJson->success != "true") {
            die("<header>Invalid captcha.</header>");
        }

        if (strlen($_POST["report"]) < 1) {
            die("Error. Report must have content.\n<a href='/'>Go Back</a>");
        } elseif (strlen(str_replace("\n", "", $_POST["report"])) > 3000) {
            die(
                "Error. Report must be 3000 characters or fewer.<br>It is currently " .
                strlen(str_replace("\n", "", $_POST["report"])) .
                " characters.<br><a href='/'>Go Back</a>"
            );
        }

        $allowedTags = '<img><br><h1><h2><h3><h4><h5><h6><b><strong><i><em><ul><ol><li>';
        $reportContent = strip_tags($_POST["report"], $allowedTags);

        $idchars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
        $id = $idchars[rand(0, 51)];
        for ($i = 0; $i < 24; $i++) {
            $id = $id . $idchars[rand(0, 61)];
        }
        $path = "../reports/" . $id . ".html";
        $file = fopen($path, "w");
        if ($file == false) {
            die("Error creating report.");
        }
        fwrite($file, $reportContent);
        fclose($file);
        echo 'Report submitted!<br><p>Your report ID is ' . $id . '.</p><a href=' . $path . '>View Report</a><br><a href=/send?id=' . $id . '>Submit Report</a>';
        ?>
    </main>
</div>
</body>
</html>