<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Verification Result</title>
  <link rel="stylesheet" href="/style.css">
</head>
<body>
  <div class="container result-container">
    <header>
      <h1>Verify Signature</h1>
    </header>
    <?php
        if (!$_POST["h-captcha-response"]) {
            die("<header>Captcha not completed.</header>");
        }
        $secret = getenv("secret");
        $response = $_POST["h-captcha-response"];
    
        $url = "https://api.hcaptcha.com/siteverify";
        $data = [
            "response" => $response,
            "secret" => $secret,
        ];
    
        $options = [
            "http" => [
                "header" => "Content-type: application/x-www-form-urlencoded\r\n",
                "method" => "POST",
                "content" => http_build_query($data),
            ],
        ];
    
        $context = stream_context_create($options);
        $result = file_get_contents($url, false, $context);
    
        if ($result === false) {
            die("<header>Failed to validate captcha.</header>");
        }
    
        $resultJson = json_decode($result);
        if ($resultJson->success != "true") {
            die("<header>Invalid captcha.</header>");
        }
    
        $signature = base64_encode($_POST["signature"]);
        $result = shell_exec(
            "python H1ddeN_V3rifY.py \"" . $signature . "\""
        );
    ?>
    <header>
        <h1>Result</h1>
        <div class="result">
          <?php echo $result; ?>
        </div>
    </header>
  </div>
</body>
</html>
